"""
__version__ = "$Revision: 1.3 $"
__date__ = "$Date: 2001/08/10 02:01:23 $"
"""

import os
from res import *

PYTHONCARD_CONFIG_FILE = 'pythoncard.config.py'
PYTHONCARD_USER_CONFIG_FILE = 'pythoncard.user.config.py'

class Configuration :
    """
    Provides access to PythonCard's runtime configuration options.
    """

    class ConfigurationImpl :

        def __init__( self ) :
            basePath = os.path.dirname( os.path.abspath( __file__ ) )
            path = os.path.join( basePath, PYTHONCARD_USER_CONFIG_FILE )
            # KEA 2001-08-09
            # first look in the directory of the program we're going to run
            # can't do this yet, given how the loader runs right now
            # then look for a user config file, then finally use the default
            #if os.path.exists(PYTHONCARD_USER_CONFIG_FILE):
            #    self._resource = ResourceFile( PYTHONCARD_USER_CONFIG_FILE ).getResource()
            if os.path.exists(path):
                #print "using", path
                self._resource = ResourceFile( path ).getResource()
                #print self._resource
            else:
                path = os.path.join( basePath, PYTHONCARD_CONFIG_FILE )
                self._resource = ResourceFile( path ).getResource()
        
        def setOption( self, name, value ) :
            setattr( self._resource, name, value )
            #eval( 'self._resource.' + name + ' = ' + value )

        def getOption( self, name ) :
            if hasattr( self._resource, name ) :
                return eval( 'self._resource.' + name )
            else :
                return None

        def getGuiToolkitName( self ) :
            return self._resource.gui

        def getLogFileName( self ) :
            return self._resource.logfile

    _impl = None

    def __init__( self ) :
        if Configuration._impl is None :
            Configuration._impl = self.ConfigurationImpl()

    def setOption( self, name, value ) :
        Configuration._impl.setOption( name, value )

    def getOption( self, name ) :
        return Configuration._impl.getOption( name )

    def getGuiToolkitName( self ) :
        return Configuration._impl.getGuiToolkitName()

    def getLogFileName( self ) :
        return Configuration._impl.getLogFileName()
        
if __name__ == '__main__' :
    __file__ = 'config.py'
    print 'config.py - Unit Test'
    Configuration().setOption( 'myOption', 'myValue' )
    print Configuration().getOption( 'myOption' )
    print 'showMessageWatcher=', Configuration().getOption( 'showMessageWatcher' )
    Configuration().setOption( 'showMessageWatcher', 1 )
    print 'showMessageWatcher=', Configuration().getOption( 'showMessageWatcher' )
