#!/usr/bin/python

"""
__version__ = "$Revision: 1.3 $"
__date__ = "$Date: 2001/08/09 20:27:01 $"
"""

import config
import model
import log
#import dialog
import os, sys

"""
Start a PythonCardApp based on a Resource file
"""

def hasOption( aOption ) :
    for arg in sys.argv :
        if arg == aOption :
            return 1
    return 0

def configOptions():
    # KEA 2001-08-09
    # this needs to be reworked, the old implementation overwrites whatever
    # might be in the .config.py files
    # also this implementation can only turn on an option, not turn it off
    if hasOption('-p'):
        config.Configuration().setOption('showPropertyEditor', 1)
    if hasOption('-m'):
        config.Configuration().setOption('showMessageWatcher', 1)
    if hasOption('-l'):
        config.Configuration().setOption('enableLogging', 1)
    if hasOption('-s'):
        config.Configuration().setOption('showShell', 1)

if __name__ == '__main__':
    if len(sys.argv) > 1:
        base, ext = os.path.splitext(sys.argv[1])
        filename = base + ".rsrc.py"    # always load the resource file, not the main module
    else:
        print "Usage: python loader.py filename [-l] [-m] [-p] [-s]"
        sys.exit()
        # KEA can't do the file loading below unless we have our hidden "parent" window
        # so startup would need to be changed, but I think prompting with an open dialog
        # if a command-line arg isn't provided would be good
        # maybe we can do this for 0.4 and fix the inability of the debug windows to go
        # behind the main window at the same time...
        """
        wildcard = "PythonCard resource files (*.rsrc.py)|*.rsrc.py|All Files (*.*)|*.*"
        dlg = dialog.FileDialog(self, 'Open', '', '', wildcard )
        if dlg.accepted():
            base, ext = os.path.splitext(dialog.getPaths()[0])
            filename = base + ".rsrc.py"
        else:
            sys.exit()
        """

    # KEA shouldn't this occur after Configuration?
    log.Log.getInstance().debug('Running ' + filename + '...')

    configOptions()

    app = model.PythonCardApp(filename)
    app.MainLoop()   


