"""
__version__ = "$Revision: 1.1.1.1 $"
__date__ = "$Date: 2001/08/06 19:53:13 $"
"""

from model import *

class StackIterator :

    def __init__( self, aStack ) :
        self._stack = aStack
        self._curBgIterator = None
        self._setCurrentBackground( aStack.getBackgroundByNumber( 1 ) )
        self._index = 1

    def newBackground( self, aName ) :
        self._stack.newBackground( aName, None )
        self.goLastBackground()
        self._index = self._stack.getNumBackgrounds()

    def deleteBackground( self ) :
        assert self._index != 1 , 'cannot delete only Background!'
        self._stack.deleteBackground( getCurrentBackground().getId() )
        self._index = self._index - 1

    def getCurrentBackground( self ) :
        return self._curBgIterator.getBackground()

    def goNextBackground( self ) :

        if self._index < self._stack.getNumBackgrounds() :
            self._index = self._index + 1
        else :
            self._index = 1

        self.goIndexedBackground( self._index )

    def goPreviousBackground( self ) :

        if self._index == 1 :
            self._index = self._stack.getNumBackgrounds()
        else :
            self._index = self._index -1 

        self.goIndexedBackground( self._index )

    def goFirstBackground( self ) :
        self._setCurrentBackground( self._stack.getFirstBackground() )

    def goLastBackground( self ) :
        self._setCurrentBackground( self._stack.getLastBackground() )

    def goIndexedBackground( self, aIndex ) :
        self._setCurrentBackground( self._stack.getBackgroundByNumber( aIndex ) )
        self._index = aIndex

    def goNamedBackground( self, aName ) :
        self._setCurrentBackground( self._stack.getBackgroundByName( aName ) )
        self._index = self._stack.getIndexOfBackground( self.getCurrentBackground() )

    def _setCurrentBackground( self, aBackground ) :
        self._curBgIterator = BackgroundIterator( aBackground )

    def __repr__( self ) :
        return str( self._stack.__dict__ )

class BackgroundIterator :

    def __init__( self, aBackground ) :
        self._background = aBackground
        self._curCard = None
        self._setCurrentCard( aBackground.getCardByNumber( 1 ) )

    def getBackground( self ) :
        return self._background

    def newCard( self ) :
        pass

    def deleteCard( self ) :
        pass

    def getCurrentCard( self ) :
        pass

    def goNextCard( self ) :
        pass

    def goPreviousCard( self ) :
        pass

    def goFirstCard( self ) :
        pass

    def goLastCard( self ) :
        pass

    def goIndexedCard( self, aIndex ) :
        pass

    def _setCurrentCard( self, aCard ) :
        self._curCard = aCard


