#!/usr/bin/python

"""
__version__ = "$Revision: 1.4 $"
__date__ = "$Date: 2001/08/14 23:48:21 $"

Note that there is a window refresh issue with the code below.
I'm setting a multiline static text field, which is dynamically
resizing the static text field to fit the content. If you resize
or hide the window then the text appears okay.
"""

import time
import PythonCardPrototype
from PythonCardPrototype.dialog import *
from PythonCardPrototype.loader import configOptions
import os, sys

# KEA what kind of name conflicts do we need to watch for
# with the class name? the class was called Proof, but I renamed
# it Dialogs
class Dialogs( PythonCardPrototype.model.Background ) :

    def on_buttonColor_mouseClick(self, target, event):
        dialog = ColorDialog(self)
        s = self.components.static1
        s.text = "ColorDialog result:\naccepted: %s\nColor: %s" % (dialog.accepted(), dialog.getColor())

    def on_buttonFont_mouseClick(self, target, event):
        dialog = FontDialog(self)
        s = self.components.static1
        color = dialog.getColor()
        font = dialog.getFont()
        s.text = "FontDialog result:\naccepted: %s\nColor: %s\nFont: %s" % (dialog.accepted(), color, font)

    def on_buttonFile_mouseClick(self, theTarget, event):
        wildcard = "JPG files (*.jpg;*.jpeg)|*.jpg;*.jpeg|GIF files (*.gif)|*.gif|All Files (*.*)|*.*"
        # wildcard = '*.py'
        dialog = FileDialog(self, 'Open', '', '', wildcard )
        s = self.components.static1
        s.text = "FileDialog result:\naccepted: %s\npaths: %s" % (dialog.accepted(), dialog.getPaths())
        # field need to support multiline
        # before a \n can be inserted correctly
        # so use a static field instead
        #field2 = self.components.static1
        #field2.setText("FileDialog result:\naccepted: %s\npaths: %s" % (dialog.accepted(), dialog.getPaths()))

    def on_buttonDir_mouseClick(self, theTarget, event):
        dialog = DirectoryDialog(self, 'Choose a directory', 'a')
        s = self.components.static1
        s.text = "DirectoryDialog result:\naccepted: %s\npath: %s" % (dialog.accepted(), dialog.getPath())

    """
    You can pass in a specific icon (default is ICON_INFORMATION)
    as well as the buttons (default is BUTTON_OK | BUTTON_CANCEL)
    
    ICON_EXCLAMATION    # Shows an exclamation mark icon.  
    ICON_HAND           # Shows an error icon.  
    ICON_ERROR          # Shows an error icon - the same as wxICON_HAND.  
    ICON_QUESTION       # Shows a question mark icon.  
    ICON_INFORMATION    # Shows an information (i) icon.

    BUTTON_OK           # Show an OK button.  
    BUTTON_CANCEL       # Show a Cancel button.  
    BUTTON_YES_NO       # Show Yes and No buttons.  
    BUTTON_YES_DEFAULT  # Used with wxYES_NO, makes Yes button the default - which is the default behaviour.  
    BUTTON_NO_DEFAULT   # Used with wxYES_NO, makes No button the default.  
    """
    def on_buttonMessage_mouseClick(self, theTarget, event):
        dialog = MessageDialog(self, 'a message', 'a title',
                               ICON_ERROR, BUTTON_YES_NO)
        #dialog = MessageDialog(self, 'a message', 'a title')
        s = self.components.static1
        s.text = "MessageDialog result:\naccepted: %s\nreturned: %s" % (dialog.accepted(), dialog.returned())

    # you can pass in an additional aStyle parameter
    # of TEXT_PASSWORD
    def on_buttonTextEntry_mouseClick(self, theTarget, event):
        dialog = TextEntryDialog(self, 
                                    'A window title', 
                                    'What is your favorite language?',
                                    'Python') #, TEXT_PASSWORD)
        s = self.components.static1
        s.text = "TextEntryDialog result:\naccepted: %s\nreturned: %s\ntext: %s" % (dialog.accepted(), dialog.returned(), dialog.getText())

    def on_buttonScrolledMessage_mouseClick(self, theTarget, event):
        base, ext = os.path.splitext(__file__) # os.path.abspath(__file__)
        filename = base + ".py"
        #print os.path.abspath(__file__)
        #filename = "test_dialogs.py"
        if os.path.exists(filename):
            f = open(filename, "r")
            msg = f.read()
        else:
            msg = "Can't find the file test_dialogs.py"
        dialog = ScrolledMessageDialog(self, msg, filename)
        s = self.components.static1
        s.text = "ScrolledMessageDialog result:\naccepted: %s" % dialog.accepted()

    def on_buttonAlert_mouseClick(self, theTarget, event):
        dialog = AlertDialog(self, 'a message', 'a title')
        s = self.components.static1
        s.text = "AlertDialog result:\naccepted: %s\nreturned: %s" % (dialog.accepted(), dialog.returned())

    def on_menuFileExit_select(self, theTarget, event):
        self.Close()


if __name__ == '__main__':
    base, ext = os.path.splitext(sys.argv[0])
    filename = base + ".rsrc.py"

    configOptions()

    app = PythonCardPrototype.model.PythonCardApp(filename)
    app.MainLoop()
