#!/usr/bin/python

"""
KEA notes to myself

Created: 2001-07-25
__version__ = "$Revision: 1.3 $"
__date__ = "$Date: 2001/08/14 01:45:05 $"
__author__ = "Kevin Altis<altis@semi-retired.com>"


"""

import urllib
import webbrowser
import pprint
import os, sys

import PythonCardPrototype
from PythonCardPrototype import dialog
from PythonCardPrototype.loader import configOptions
#import res
from sgrepmod import *
import string

class FindFiles(PythonCardPrototype.model.Background):
    def __init__(self, aParent, aId, aStackRsrc, aBgRsrc):
        PythonCardPrototype.model.Background.__init__(self, aParent, aId, aStackRsrc, aBgRsrc)
        self.dir = None

    def on_btnChangeDirs_mouseClick(self, button, event):
        wildcard = "Grep files (*.grep)|*.grep"
        path = ''
        filename = ''
        dlg = dialog.FileDialog(self, 'Open', path, filename, wildcard)
        if dlg.accepted():
            s = dlg.getPaths()[0]
            self.dir = os.path.dirname(s)
            fileList = [] 
            filenames = os.listdir(self.dir)
            for fName in filenames:
                root, ext = os.path.splitext(fName)
                if ext == '.grep':
                    fileList.append(fName)
            fileList.sort() # again, need a case-insensitive sort
            self.components.listFiles.items = fileList

    def setSearchParams(self, searchPattern='', dirs='', wildcard='', caseSensitive=0,
                        searchSubdirectories=1, verbose=0):
        self.components.fldSearchPattern = searchPattern
        self.components.fldDirectories = dirs
        self.components.fldWildcard = wildcard
        self.components.chkCaseSensitive = caseSensitive
        self.components.chkSearchSubdirectories = searchSubdirectories
        self.components.chkVerbose = verbose

    def loadGrepFile(self, filename):
        file = open(filename)
        txt = file.read()
        file.close()
        dirs, wildcard, searchPattern, caseSensitive, searchSubdirectories, verbose = txt.split('\t')
        self.setSearchParams(searchPattern, dirs, wildcard, caseSensitive == '1',
                             searchSubdirectories == '1', verbose == '1')
        
    def on_listFiles_select(self, list, event):
        filename = os.path.join(self.dir, list.getSelection())
        #print filename
        self.loadGrepFile(filename)

    def doSearch(self):
        self.dp = dirpath(self.dirpattern, self.recurse)
        print "Grep for %s in %s" % (self.greppattern, self.filpattern)
        #self.text = []
        print '#Search '+self.dirpattern+'\n'
        if self.verbose:
            print '#   ='+`self.dp.dirs`+'\n'
        print '# Files '+self.filpattern+'\n'
        print '#   For '+self.greppattern+'\n'
        self.fplist = string.split(self.filpattern,';')
        regex.set_syntax(regex_syntax.RE_SYNTAX_GREP)
        if self.casesensitive:
            self.pat = regex.compile(self.greppattern)
        else:
            self.pat = regex.compile(self.greppattern, regex.casefold)
        print "Searching.  Please wait..."
        self.dpndx = self.fpndx = 0
        self.fndx = -1
        if not self.dp:
            print "# ERROR: '%s' does not resolve to any search locations" % self.dirpattern
            #self.SetModifiedFlag(0)
        else:
            # KEA was self.flist = glob.glob(self.dp[0]+'\\'+self.fplist[0])
            self.flist = glob.glob(os.path.join(self.dp[0], self.fplist[0]))
            #self.find('listResults').setItems(self.flist)
            print '***********************'
            self.searching = 1
            self.resultList = []
            #self.resultList = ''
            while self.searching:
                self.SearchFile()
            #self.find('listResults').setItems(self.resultList)
            wListResults = self.components.listResults
            wListResults.text = string.join(self.resultList, "\n")
            #print self.flist
            #win32ui.GetApp().AddIdleHandler(self.SearchFile)

    def SearchFile(self):
        self.fndx = self.fndx + 1
        if self.fndx < len(self.flist):
            f = self.flist[self.fndx]
            if self.verbose:
                print '# ..'+f+'\n'
            #print "Searching "+f
            lines = open(f, 'r').readlines()
            # KEA 2001-06-05
            found = 0
            for i in range(len(lines)):
                line = lines[i]
                if self.pat.search(line) >= 0:
                    # KEA 2001-06-05
                    if not found:
                        #print f+'\n'
                        self.resultList.append(f)
                        #self.resultList += f + '\n'
                        found = 1
                    #print '  '+`i+1` + ': '+line
                    self.resultList.append('  '+`i+1` + ': '+line[:-1])
                    #self.resultList += '  '+`i+1` + ': '+line[:-1] + '\n'
                #   self.GetFirstView().Append(f+'('+`i+1` + ') '+line)
        else:
            # KEA 2001-06-05
            # not sure if I need to modify this section
            self.fndx = -1
            self.fpndx = self.fpndx + 1
            if self.fpndx < len(self.fplist):
                #KEA was self.flist = glob.glob(self.dp[self.dpndx] + '\\' + self.fplist[self.fpndx])
                self.flist = glob.glob(os.path.join(self.dp[self.dpndx], self.fplist[self.fpndx]))
            else:
                self.fpndx = 0
                self.dpndx = self.dpndx + 1
                if self.dpndx < len(self.dp):
                    #KEA was self.flist = glob.glob(self.dp[self.dpndx] + '\\' + self.fplist[self.fpndx])
                    self.flist = glob.glob(os.path.join(self.dp[self.dpndx], self.fplist[self.fpndx]))
                else:
                    print "Search complete."
                    #self.SetModifiedFlag(0) # default to not modified.
                    try:
                        #win32ui.GetApp().DeleteIdleHandler(self.SearchFile)
                        self.searching = 0
                        pass
                    except:
                        pass
                    return 0
        return 1

    def on_btnSearch_mouseClick(self, button, event):
        self.greppattern = self.components.fldSearchPattern.text
        self.dirpattern = self.components.fldDirectories.text
        self.filpattern = self.components.fldWildcard.text
        self.casesensitive = self.components.chkCaseSensitive.checked
        self.recurse = self.components.chkSearchSubdirectories.checked
        self.verbose = self.components.chkVerbose.checked
        #print self.greppattern
        #print self.dirpattern
        #print self.filpattern
        #print self.casesensitive
        #print self.recurse
        #print self.verbose
        self.doSearch()

    def on_btnAddDirs_mouseClick(self, button, event):
        wFldDirectories = self.components.fldDirectories
        dirs = wFldDirectories.text
        dlg = dialog.DirectoryDialog(self, '', '')
        if dlg.accepted():
            s = dlg.getPath()
            if dirs == "":
                wFldDirectories.text = s
            else:
                found = 0
                # should the search be case-insensitive?
                for dir in dirs.split(";"):
                    if s.upper() == dir.upper():
                        found = 1
                        break
                if not found:
                    wFldDirectories.text = dirs + ";" + s

    def on_menuFileExit_select(self, menu, event):
        self.Close()


if __name__ == '__main__':
    base, ext = os.path.splitext(sys.argv[0])
    filename = base + ".rsrc.py"

    configOptions()

    app = PythonCardPrototype.model.PythonCardApp(filename)
    app.MainLoop()
