import string
import regex
import regex_syntax
import glob
import os
import stat
#import glob


def getsubdirs(d):
    dlist = []
    flist = glob.glob(d+'\\*')
    for f in flist:
        if os.path.isdir(f):
            dlist.append(f)
            dlist = dlist + getsubdirs(f)
    return dlist

class dirpath:
    def __init__(self, str, recurse=0):
        dp = string.split(str, ';')
        dirs = {}
        for d in dp:
            if os.path.isdir(d):
                d = string.lower(d)
                if not dirs.has_key(d):
                    dirs[d] = None
                    if recurse:
                        subdirs = getsubdirs(d)
                        for sd in subdirs:
                            sd = string.lower(sd)
                            if not dirs.has_key(sd):
                                dirs[sd] = None
            elif os.path.isfile(d):
                pass
            else:
                x = None
                if os.environ.has_key(d):
                    x = dirpath(os.environ[d])
                elif d[:5] == 'HKEY_':
                    keystr = string.split(d,'\\')
                    try:
                        #root = eval('win32con.'+keystr[0])
                        pass
                    except:
                        print "Can't interpret registry key name '%s'" % keystr[0]
                    try:
                        subkey = string.join(keystr[1:], '\\')
                        #val = win32api.RegQueryValue(root, subkey)
                        if val:
                            x = dirpath(val)
                        else:
                            print "Registry path '%s' did not return a path entry" % d
                    except:
                        print "Can't interpret registry key value: %s" % keystr[1:]
                else:
                    print "Directory '%s' not found" % d
                if x:
                    for xd in x:
                        if not dirs.has_key(xd):
                            dirs[xd] = None
                            if recurse:
                                subdirs = getsubdirs(xd)
                                for sd in subdirs:
                                    sd = string.lower(sd)
                                    if not dirs.has_key(sd):
                                        dirs[sd] = None
        self.dirs = []
        for d in dirs.keys():
            self.dirs.append(d)

    def __getitem__(self, key):
        return self.dirs[key]
    def __len__(self):
        return len(self.dirs)
    def __setitem__(self, key, value):
        self.dirs[key] = value
    def __delitem__(self, key):
        del self.dirs[key]
    def __getslice__(self, lo, hi):
        return self.dirs[lo:hi]
    def __setslice__(self, lo, hi, seq):
        self.dirs[lo:hi] = seq
    def __delslice__(self, lo, hi):
        del self.dirs[lo:hi]
    def __add__(self, other):
        if type(other) == type(self) or type(other) == type([]):
            return self.dirs + other.dirs
    def __radd__(self, other):
        if type(other) == type(self) or type(other) == type([]):
            return other.dirs + self.dirs
