#!/usr/bin/python

"""
__version__ = "$Revision: 1.8 $"
__date__ = "$Date: 2001/08/23 18:56:51 $"

I'll add support for editing the .txt file scripts once we have a multi-window
framework in place and a decent way of doing at least rudimentary editing,
syntax highlighting, syntax checking, etc. In other words, not until scintilla
is running inside the PythonCard framework to give us styled text fields and
more.
"""

import PythonCardPrototype
from PythonCardPrototype.loader import configOptions
import os, sys

import time
from math import * # Also for export
from wxPython.wx import *
import wxTurtle

class TurtleBg(PythonCardPrototype.model.Background):

    """
    as per other samples, __init__ will go away once we are doing
    openStack, openBackground messages
    the font initialization, dc, and other wxPython code exposed below
    will be hidden as those features are added to the PythonCard
    framework
    """
    def __init__(self, aParent, aId, aStackRsrc, aBgRsrc):
        PythonCardPrototype.model.Background.__init__(self, aParent, aId, aStackRsrc, aBgRsrc)

        self.setBackgroundColor('white')
        if wxPlatform == '__WXGTK__':
            self.font = wxFont(12, wxMODERN, wxNORMAL, wxNORMAL)
        else:
            self.font = wxFont(10, wxMODERN, wxNORMAL, wxNORMAL)
        #self.SetFocus()
        self.fNameTurtleScript = "scripts/4bugs.txt"

    def doDraw(self):
        #global dc
        dc = wxTurtle.TurtleDC(self.panel)
        dc.BeginDrawing()
        #dc.SetPen(wxPen(wxNamedColour('blue')))
        #dc.SetPen(wxBLACK_PEN)

        #if eventid == ID_DRAWTURTLE:
        input = open(self.fNameTurtleScript, 'r')
        codeString = input.read()
        input.close()
        namespace = {}   # Just an empty dictionary
        exec(codeString, None, namespace)
        func = namespace['drawMain']  # or some other predefined name
        func(dc, self)
            
        dc.EndDrawing()

    def on_menuFileOpen_select(self, menu, event):
        currentDir = os.getcwd()
        wildcard = "Turtle files (*.txt)|*.txt"
        path = 'scripts'
        filename = ''
        dlg = PythonCardPrototype.dialog.FileDialog(self, 'Open', path, filename, wildcard)
        if dlg.accepted():
            self.fNameTurtleScript = dlg.getPaths()[0]
            os.chdir(currentDir)
            self.doDraw()

    def on_menuFileDrawTurtle_select(self, menu, event):
        self.doDraw()

    def on_menuFileExit_select(self, menu, event):
        self.Close()

    def on_menuCommandsClear_select(self, menu, event):
        # this is unclean and will need to be changed
        # I'll change it after I think more about what sorts
        # of commands I want to support in the menu and whether
        # they should be global or specific to individual turtles
        self.panel._getDelegate().Refresh()

if __name__ == '__main__':
    base, ext = os.path.splitext(sys.argv[0])
    filename = base + ".rsrc.py"

    configOptions()
    # now force the shell to be enabled
    PythonCardPrototype.config.Configuration().setOption('showShell', 1)

    app = PythonCardPrototype.model.PythonCardApp(filename)
    app.MainLoop()
