#!/usr/bin/python

"""
KEA notes to myself

Created: 2001-07-22
__version__ = "$Revision: 1.4 $"
__date__ = "$Date: 2001/08/24 00:15:52 $"
__author__ = "Kevin Altis<altis@semi-retired.com>"

I'm using an ImageButton rather than an image because I want to catch
mouseMove (hmm, should that be mouseOver ?) events and pop up a relative
time for east coast, midwest, london, sydney, etc.

However, we need the option to set style=0 rather than the default
wxBU_AUTODRAW.

http://www.time.gov/images/xearths/night.jpg
"""

import urllib
import os, sys
import time
from wxPython.wx import *

import PythonCardPrototype
from PythonCardPrototype.loader import configOptions
from PythonCardPrototype import widget

import xearth

class WorldClock(PythonCardPrototype.model.Background):

    def __init__(self, aParent, aId, aStackRsrc, aBgRsrc):
        PythonCardPrototype.model.Background.__init__(self, aParent, aId, aStackRsrc, aBgRsrc)
        self.clock = ''
        self.lastUpdate = 0
        self.url = ''
        self.interval = 5 * 60   # 5 minutes

        # this should be handled by our own idle event
        # so that updateImageAndClock would be called from
        # def background_idle(self, event):
        #     self.updateImageAndClock()
        self.timer = wxTimer(self, -1)
        self.timer.Start(1000)  # force idle once a second
        EVT_IDLE(self, self.updateImageAndClock)

    def updateImageAndClock(self, event):
        now = time.time()
        #s = str(time.asctime(time.localtime(now)))
        s = time.strftime("%I:%M %p")
        d = time.strftime("%A, %B %d, %Y")
        if s[0] == "0":
            s = s[1:]
        if self.clock == s:
            return

        self.clock = s
        self.components.staticTextClock.text = s
        self.components.staticTextDate.text = d

        #print now - self.lastUpdate
        if now - self.lastUpdate < self.interval:
            return

        # Change this to a logging call
        print "%s : interval is up..." % s
        self.lastUpdate = now
        # try:
        #    jScript = "cscript //nologo xearth.js"
        #    file = os.popen(jScript)
        #    s = file.read()
        #    url = "http://www.time.gov/" + s
        # except:
        #    url = "http://www.time.gov/images/xearths/night.jpg"
        #    #url = "http://www.time.gov/images/xearths/11N/100N.jpg"
        url = "http://www.time.gov/" + xearth.getLatLong()

        if url == self.url:
            return

        self.url = url
        print "updating image", url
        #sys.exit()
        # download image from www.time.gov
        fp = urllib.urlopen(url)
        jpg = fp.read()
        fp.close()

        wImageButtonWorld = self.components.imageButtonWorld

        f = open('night2.jpg', "wb")
        f.write(jpg)
        f.close()

        newBitmap = widget.Bitmap('night2.jpg')

        """
        # I couldn't get the raw data to translate into a bitmap
        # correctly, so I resorted to writing a file to disk
        # and then reading it back in
        bmp = wImageButtonWorld.getBitmap()
        width = bmp.GetWidth()
        height = bmp.GetHeight()
        print width
        print height
        newBitmap = wxBitmapFromData(jpg, wxBITMAP_TYPE_JPEG, width, height, -1)
        """

        wImageButtonWorld.bitmap = newBitmap

    def on_menuFileExit_select(self, menu, event):
        self.Close()


if __name__ == '__main__':
    base, ext = os.path.splitext(sys.argv[0])
    filename = base + ".rsrc.py"

    configOptions()

    app = PythonCardPrototype.model.PythonCardApp(filename)
    app.MainLoop()
