"""
__version__ = "$Revision: 1.1.1.1 $"
__date__ = "$Date: 2001/08/06 19:53:13 $"
"""

from wxPython.wx import *

SOUND_TYPE_WAVE = 1
SOUND_TYPE_SUNAUDIO = 2

class Sound:
    """
    Feeble beginnings of a class for playing sounds.
    The goal is to be able to provide a filename and then be able
    to play the sound without worrying about sound formats or particular
    OS capabilities. I haven't investigated the Python Standard Libraries
    yet.
    """
    
    def __init__(self, filename) :
        self._filename = filename
        self._sndType = self._soundType(filename)
        if self._sndType == SOUND_TYPE_WAVE:
            try:
                self._sound = wxWave(filename)    # support resources?
            except:
                pass    # what's an appropriate error

    def _soundType(self, filename) :
        """
        Get the type of a sound from the file's extension ( .wav, etc. )
        """
        name, ext = filename.split( '.' )
        ext = ext.upper()
        if ext == 'WAV':
            return SOUND_TYPE_WAVE
        elif ext == 'AU':
            return SOUND_TYPE_SUNAUDIO
        else:
            raise 'invalid sound format'    # should throw an exception here

    def play(self, async=1, looped=0) :
        # I guess there could be another error here
        if self._sndType == SOUND_TYPE_WAVE:
            self._sound.Play(async, looped)
